/**
 * Facebook debug test: though we don't use any FB functions, we do expect the cordova-plugin-facebook4 to be present
 * @moduleName FacebookTest
 */
bento.define('debug/tests/facebook', [
    'bento',
    'bento/utils'
], function (
    Bento,
    Utils
) {
    'use strict';
    var Test = function (settings) {
        return [{
            name: 'Plugin exists',
            run: function (htmlContainer, onSuccess, onFail) {
                if (window.facebookConnectPlugin) {
                    onSuccess('PASS');
                } else {
                    onFail('FAIL: missing global variable window.facebookConnectPlugin');
                }
            }
        }, {
            name: 'Login status',
            run: function (htmlContainer, onSuccess, onFail) {
                if (!window.facebookConnectPlugin) {
                    onFail('FAIL: missing global variable window.facebookConnectPlugin');
                    return;
                }
                window.facebookConnectPlugin.getLoginStatus(function (params) {
                    onSuccess('PASS: ' + JSON.stringify(params));
                }, function () {
                    onFail('FAIL: error callback from facebookConnectPlugin.getLoginStatus');
                })
            }
        }];
    };
    return Test;
});