/**
 * SystemData debug test
 * @moduleName SystemDataTest
 */
bento.define('debug/tests/systemdata', [
    'bento',
    'bento/utils'
], function (
    Bento,
    Utils
) {
    'use strict';
    var Test = function (settings) {
        return [{
            name: 'Plugin exists',
            run: function (htmlContainer, onSuccess, onFail) {
                if (window.SystemData) {
                    onSuccess('PASS');
                } else {
                    onFail('FAIL: missing global variable window.SystemData');
                }
            }
        }, {
            name: 'Get IDFA',
            run: function (htmlContainer, onSuccess, onFail) {
                if (window.SystemData) {
                    if (window.SystemData.advertising_id) {
                        window.SystemData.advertising_id(function (idfa) {
                            if (idfa) {
                                onSuccess('PASS: ' + idfa);
                            } else {
                                onFail('FAIL: limited ad tracking (?)');
                            }
                        }, function () {
                            onFail('FAIL: plugin faulty or limited ad tracking');
                        });
                    } else {
                        onFail('FAIL: missing global variable window.SystemData.advertising_id');
                    }
                } else {
                    onFail('FAIL: missing global variable window.SystemData');
                }
            }
        }];
    };
    return Test;
});