/**
 * A module made SPECIFCIALLY for Nom Plant to allow swapping between Toutiao and IronSource
 * @moduleName Ads
 * @snippet Ads.snippet
 */
bento.define('modules/ads', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'modules/ironsource',
    'modules/toutiao'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween,
    IronSource,
    Toutiao
) {
    'use strict';

    // Bytedance Ads
    var BDAds = {
        init: function () {
            // BytedanceAds.initialize({
            //     appID: '5001121',
            //     appName: 'Mouth Plant',
            //     autoLoadInteractionAds: true,
            //     autoLoadRewardedAds: true,
            //     interactionCodeID: '901121725',
            //     rewardedCodeID: '901121365'
            // });
            Toutiao.initialize({
                appID: Utils.isNativeIos() ?
                    '5020452' : //iOS
                    '5024490', //Android
                appName: 'nomplant',
                autoLoadFullscreenVideoAds: true,
                autoLoadRewardedAds: true,
                fullscreenVideoCodeID: Utils.isNativeIos() ?
                    '920452662' : //iOS
                    '924490797', //Android
                rewardedCodeID: Utils.isNativeIos() ?
                    '920452615' : //iOS
                    '924490704' //Android
            });
        },
        canShowRewarded: function () {
            return Toutiao.canShowRewarded();
        },
        showRewarded: function (success, failure, placement) {
            Toutiao.showRewarded(success, failure);
        },
        canShowInterstitial: function (yes, no) {
            Toutiao.canShowFullScreenVideo(yes, no);
        },
        showInterstitial: function (success, failure) {
            Toutiao.showFullScreenVideo(success, failure);
        }
    };

    // IronSource Ads
    var ISAds = {
        init: function () {
            IronSource.initialize({
                appKey: Utils.isNativeIos() ? '864af795' : '8f8b696d',
                clientCallback: false,
                autoLoadInterstitials: true
            }, function () {
                IronSource.setUserConsent(true);
            }, function (e) {
                console.log(e);
            });
        },
        canShowRewarded: function () {
            return IronSource.canShowRewarded();
        },
        showRewarded: function (success, failure, placement) {
            IronSource.showRewarded(success, failure, placement);
        },
        canShowInterstitial: function (yes, no) {
            IronSource.canShowInterstitial(yes, no);
        },
        showInterstitial: function (success, failure, placement) {
            IronSource.showInterstitial(success, failure, placement);
        }
    };

    return (window.ISCHINA) ? BDAds : ISAds;
});